//Copyright (c) 1998 The Open Group
//
//Permission to use, copy, modify, and distribute this software and its documentation for
//any purpose and without fee is hereby granted, provided that the above copyright notice
//appears in all copies and that both the copyright notice and this permission notice
//appear in supporting documentation, and that the name of ("TOG") or The Open Group not
//be used in advertising or publicity pertaining to distribution of the software without
//specific, written prior permission.
//
//THE OPEN GROUP DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL
//IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. IN NO EVENT
//SHALL TOG BE LIABLE FOR ANY SPECIAL, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
//WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN ACTION OF CONTRACT,
//NEGLIGENCE, OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
//PERFORMANCE OF THIS SOFTWARE. 

package ORG.opengroup.axtp.tp;
import ORG.opengroup.axtp.*;
import ORG.opengroup.axtp.tid.*;
import ORG.opengroup.axtp.transaction.*;
import java.io.*;

public interface TP extends TIDFactory
{
	public static final long RETENTION_TIMER = (long) -1;
	public static final long DURATION_TIMER =  (long) -2;

	public void send(PacketObject po);
	public byte[] createTID();
	public void addTC(TransactionContext tc, long transactionRetention);
	public TransactionServer getTransactionServer(byte[] tid);
	public TransactionContext getClientTC(byte[] tid);
	public long setTimer(TransactionContext tc, long context, long delay);
	public void clearTimer(TransactionContext tc, long context);
	public void clearAllTimers(TransactionContext tc);
	public void deleteTC(TransactionContext tc);
	public ExecutionContext createServerXC(X x, TransactionServer ts)
		throws ClassNotFoundException, IOException;
	public RetryDelay cloneRetryDelay();
	public TransactionFactory getTransactionFactory();
	public boolean isNoisy();
}
