//Copyright (c) 1997 The Open Group
//
//Permission to use, copy, modify, and distribute this software and its documentation for
//any purpose and without fee is hereby granted, provided that the above copyright notice
//appears in all copies and that both the copyright notice and this permission notice
//appear in supporting documentation, and that the name of ("TOG") or The Open Group not
//be used in advertising or publicity pertaining to distribution of the software without
//specific, written prior permission.
//
//THE OPEN GROUP DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL
//IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. IN NO EVENT
//SHALL TOG BE LIABLE FOR ANY SPECIAL, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
//WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN ACTION OF CONTRACT,
//NEGLIGENCE, OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
//PERFORMANCE OF THIS SOFTWARE. 

/* 
 * ORG.opengroup.moabatch.EditorPath version 0.1
 * by Bill la Forge
 * http://www.opengroup.org/~laforge
 */

package ORG.opengroup.beans;

import java.net.*;
import java.io.*;
import java.beans.*;

/**
 * Provides access to the list of packages containing property editors.
 */
public class EditorPath
{
    /**
     * Set editor path to blank-delimited list of package names.
     */
    static public void setPath(String v)
    {
        PropertyEditorManager.setEditorSearchPath(cnvt(0,v));
    }

    static String[] cnvt(int n, String s)
    {
        s=s.trim();
        if (s.length()==0)
            return new String[n];
        int x=s.indexOf(' ');
        String a[]=null;
        if (x==-1)
        {
            a=new String[n+1];
            a[n]=s;
        }
        else
        {
            a=cnvt(n+1,s.substring(x));
            a[n]=s.substring(0,x);
        }
        return a;
    }

    /**
     * Return editor path as blank-delimited list of package names.
     */
    static public String getPath()
    {
        String p[]=PropertyEditorManager.getEditorSearchPath();
        int i;
        String r="";
        for (i=0;i<p.length;++i)
            r=r+p[i]+" ";
        return r.substring(0,r.length()-1);
    }
}   
