//Copyright (c) 1997 The Open Group
//
//Permission to use, copy, modify, and distribute this software and its documentation for
//any purpose and without fee is hereby granted, provided that the above copyright notice
//appears in all copies and that both the copyright notice and this permission notice
//appear in supporting documentation, and that the name of ("TOG") or The Open Group not
//be used in advertising or publicity pertaining to distribution of the software without
//specific, written prior permission.
//
//THE OPEN GROUP DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL
//IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. IN NO EVENT
//SHALL TOG BE LIABLE FOR ANY SPECIAL, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
//WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN ACTION OF CONTRACT,
//NEGLIGENCE, OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
//PERFORMANCE OF THIS SOFTWARE. 

package ORG.opengroup.beans;
import java.io.*;
import java.util.*;

/**
 * This is a simple bean with property string which is an array of String.
 */
public class StringArray implements Serializable
{
	protected Vector v=new Vector();

	/**
	 * The size of the array
	 */
	public int getSize()
	{
		return v.size();
	}


	/**
	 * The size of the array
	 */
	public void setSize(int s)
        {
		if (s<v.size())
			v.setSize(s);
		while (s>v.size())
			v.addElement("");
        }

	/**
	 * The string representation of the array
	 */
	public String[] getString()
	{
		String a[]=new String[v.size()];
		v.copyInto(a);
		return a;
	}

	/**
	 * Initialize the array with these values
	 */
	public void setString(String a[])
	{
		v.setSize(0);
		int s=a.length;
		int i;
		for (i=0;i<s;++i)
			v.addElement(a[i]);
	}

	/**
	 * Retrieve a strnig from a specific location
	 */
	public String getString(int i)
		throws ArrayIndexOutOfBoundsException
	{
		return (String)v.elementAt(i);
	}

	/**
	 * The string at a specific location in the array
	 */
	public void setString(int i, String s)
		throws ArrayIndexOutOfBoundsException
	{
		v.setElementAt(s,i);
	}
}
