//Copyright (c) 1998 The Open Group
//
//Permission to use, copy, modify, and distribute this software and its documentation for
//any purpose and without fee is hereby granted, provided that the above copyright notice
//appears in all copies and that both the copyright notice and this permission notice
//appear in supporting documentation, and that the name of ("TOG") or The Open Group not
//be used in advertising or publicity pertaining to distribution of the software without
//specific, written prior permission.
//
//THE OPEN GROUP DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL
//IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. IN NO EVENT
//SHALL TOG BE LIABLE FOR ANY SPECIAL, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
//WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN ACTION OF CONTRACT,
//NEGLIGENCE, OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
//PERFORMANCE OF THIS SOFTWARE. 

package ORG.opengroup.misc;
import java.io.*;

/**
 * A bean which uses Java's Object Streams to serialize objects.
 */
public class JOS implements Serialization
{
	public byte[] objectToBytes(Object o)
		throws IOException
	{
		ByteArrayOutputStream baos=new ByteArrayOutputStream();
		ObjectOutputStream oos=new ObjectOutputStream(baos);
		oos.writeObject(o);
		oos.flush();
		return baos.toByteArray();
	}

	public Object bytesToObject(byte[] b)
		throws IOException, ClassNotFoundException
	{
		return bytesToObject(b,null);
	}

	public Object bytesToObject(byte[] b, ClassLoader cl)
		throws IOException, ClassNotFoundException
	{
		ByteArrayInputStream bais=new ByteArrayInputStream(b);
		ObjInStr ois=new ObjInStr(bais,cl);
		return ois.readObject();
	}
}
