//Copyright (c) 1997 The Open Group
//
//Permission to use, copy, modify, and distribute this software and its documentation for
//any purpose and without fee is hereby granted, provided that the above copyright notice
//appears in all copies and that both the copyright notice and this permission notice
//appear in supporting documentation, and that the name of ("TOG") or The Open Group not
//be used in advertising or publicity pertaining to distribution of the software without
//specific, written prior permission.
//
//THE OPEN GROUP DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL
//IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. IN NO EVENT
//SHALL TOG BE LIABLE FOR ANY SPECIAL, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
//WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN ACTION OF CONTRACT,
//NEGLIGENCE, OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
//PERFORMANCE OF THIS SOFTWARE. 

package ORG.opengroup.misc;

import java.io.*;

/**
 * This is a fast variable-length reader.
 * <p>
 * It reads into a series of buffers,
 * each buffer being twice as large as the last.
 * <p>
 * At the end, it allocates a single buffer 
 * exactly equal in length to the total bytes read.
 * It then copies everything into this final buffer.
 */
final public class Reads
{
    static public byte read(InputStream is)[] throws IOException
	{
		byte v[][]=new byte[22][];
		int vc=0;
		int s=1024;
		int t=0;
		byte b[]=new byte[s];
		v[vc]=b;
		int chunk=0;
		int offset=0;
		while (chunk!=-1)
		{
			chunk=is.read(b,offset,s-offset);
			if (chunk!=-1)
			{
				offset+=chunk;
				t+=chunk;
				if (offset==s) //not always true with a ZipInputStream
				{
					s*=2;
					vc++;
					b=new byte[s];
					v[vc]=b;
					offset=0;
				}
			}
		}
		byte o[]=new byte[t];
		int i;
		s=1024;
		int off=0;
		for (i=0;i<vc;++i)
		{
			System.arraycopy(v[i],0,o,off,s);
			off+=s;
			s*=2;
		}
		System.arraycopy(v[vc],0,o,off,offset);
		return o;
	}   
}
